﻿' Copyright © Microsoft Corporation.  All Rights Reserved.
' This code released under the terms of the 
' Microsoft Public License (MS-PL, http://opensource.org/licenses/ms-pl.html.)
'
' Copyright (c) Microsoft Corporation. All rights reserved.
' Modified for RIP testing and debugging
' AT commands removed
' Additional test boxes and fixed format protocol added
Imports System.Text

Public Class MainForm

    ' Constants used for converting 32 bits to bytes and words
    Private Const OFFSET_4 As Double = 4294967296.0#
    Private Const MAXINT_4 As Integer = 2147483647
    Private Const OFFSET_2 As Double = 65536
    Private Const MAXINT_2 As Int16 = 32767


    ' Declare necessary class variables.
    Private CommPort As New RS232()
    Private IsModemFound As Boolean = False
    Private ModemPort As Integer = 0
    Private VertPosInt As Integer = 0
    Private VertPosAng As Single = 0.0
    Private VertPosH As Byte = 0
    Private VertPosL As Byte = 0
    Private VertSetpoint As Integer = 792
    Private HorzPosInt As Integer = 0
    Private HorzPosAng As Single = 0.0
    Private HorzPosH As Byte = 0
    Private HorzPosL As Byte = 0
    Private HorzSetpoint As Integer = 512
    Private VertDir As Byte = 0
    Private OutputDriverH As Byte = 0
    Private OutputDriverL As Byte = 0
    Private OutputDriverHH As Byte = 0
    Private OutputDriverLL As Byte = 0
    Private OutputDriverPos As Long = 0
    Private ControlMode As Byte = 0
    Private OHH As Long = 0
    Private OH As Long = 0
    Private OL As Long = 0
    Private OLL As Long = 0


    Private InBufferState As Integer = 0

    ' This subroutine checks for available ports on the local machine. It does 
    '   this by attempting to open ports 1 through 4.
    Private Sub ConnectPortButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectPortButton.Click
        OpenPort(1)
        Me.tmrReadCommPort.Enabled = True
    End Sub

    ' This subroutine is fired when the timer event is raised. It writes whatever
    '   is in the Comm Port buffer to the output window.
    Private Sub tmrReadCommPort_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrReadCommPort.Tick
        Dim nextByte As Byte
        Dim nextState As Byte

        Try
            ' As long as there is information, read one byte at a time and 
            '   output it.
            While (CommPort.Read(1) <> -1)
                ' Write the output to the screen.
                nextByte = CommPort.InputStream(0)

                'WriteMessage(Hex(nextByte), False)

                If InBufferState = 0 Then
                    If nextByte = &HAA Then
                        nextState = 1
                    Else
                        nextState = 0
                    End If
                End If
                If InBufferState = 1 Then
                    If nextByte = &H55 Then
                        nextState = 2
                    Else
                        nextState = 0
                    End If
                End If
                If InBufferState = 2 Then
                    If nextByte = &HAA Then
                        nextState = 3
                    Else
                        nextState = 0
                    End If
                End If
                If InBufferState = 3 Then
                    VertPosL = nextByte
                    nextState = 4
                End If
                If InBufferState = 4 Then
                    VertPosH = nextByte
                    nextState = 5
                End If
                If InBufferState = 5 Then
                    HorzPosL = nextByte
                    nextState = 6
                End If
                If InBufferState = 6 Then
                    HorzPosH = nextByte
                    nextState = 7
                End If
                If InBufferState = 7 Then
                    VertDir = nextByte
                    nextState = 8
                End If
                If InBufferState = 8 Then
                    OutputDriverLL = nextByte
                    OLL = CLng(OutputDriverLL)
                    nextState = 9
                End If
                If InBufferState = 9 Then
                    OutputDriverL = nextByte
                    OL = CLng(OutputDriverL)
                    nextState = 10
                End If
                If InBufferState = 10 Then
                    OutputDriverH = nextByte
                    OH = CLng(OutputDriverH)
                    nextState = 11
                End If
                If InBufferState = 11 Then
                    OutputDriverHH = nextByte
                    OHH = CLng(OutputDriverHH)
                    nextState = 0
                End If


                InBufferState = nextState

                VertPosInt = UnsignedToInteger(VertPosH * 256 + VertPosL)
                VertBox1.Text = CStr(VertPosInt)

                HorzPosInt = UnsignedToInteger(HorzPosH * 256 + HorzPosL)
                HorzBox1.Text = CStr(HorzPosInt)

                If VertDir = 1 Then
                    CW.Visible = False
                    CCW.Visible = True
                End If
                If VertDir = 0 Then
                    CW.Visible = True
                    CCW.Visible = False

                End If

                OutputDriverPos = OHH * 256 * 256 * 256 + OH * 256 * 256 + OL * 256 + OLL
                If OutputDriverPos > 2147483647 Then
                    OutputDriverPos = OutputDriverPos - 4294967296
                End If
                OutDrv.Text = Hex(OutputDriverPos)
                OutDrv1.Text = CStr(OutputDriverPos / 256)


            End While
            'WriteMessage("", True)

        Catch exc As Exception
            ' An exception is raised when there is no information to read.
            '   Don't do anything here, just let the exception go.
        End Try

    End Sub


    ' This function attempts to open the passed Comm Port. If it is
    '   available, it returns True, else it returns False. To determine
    '   availability a Try-Catch block is used.
    Private Function OpenPort(ByVal ComPort As Integer) As Boolean
        Try
            CommPort.Open(ComPort, 19200, 8, RS232.DataParity.Parity_None, _
                RS232.DataStopBit.StopBit_1, 4096)
            Return True
        Catch
            ' If it gets here, then the attempt to open the Comm Port
            '   was unsuccessful.
            Return False
        End Try
    End Function
    ' This function attempts to close the passed Comm Port. If it is
    '   available, it returns True, else it returns False. To determine
    '   availability a Try-Catch block is used.
    Private Function ClosePort(ByVal ComPort As Integer) As Boolean
        Try
            CommPort.Close()
            Return True
        Catch
            ' If it gets here, then the attempt to open the Comm Port
            '   was unsuccessful.
            Return False
        End Try
    End Function




    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        End
    End Sub



    Private Sub Update1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Update1.Click
        Dim Buf() As Byte = {&H55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, &HAA}


        'ReDim Buf(31)
        Buf(1) = CByte(&H1)
        Buf(2) = CByte((IntToUnsigned(CInt(Horz_Set.Text)) >> 8) And &HFF)
        Buf(3) = CByte(IntToUnsigned(CInt(Horz_Set.Text)) And &HFF)
        Buf(4) = CByte((IntToUnsigned(CInt(Vert_Set.Text)) >> 8) And &HFF)
        Buf(5) = CByte(IntToUnsigned(CInt(Vert_Set.Text)) And &HFF)

        Buf(6) = CByte((IntToUnsigned(CInt(CSng(Horz_K1.Text) * 256)) >> 8) And &HFF)
        Buf(7) = CByte(IntToUnsigned(CInt(CSng(Horz_K1.Text) * 256)) And &HFF)

        Buf(8) = CByte((IntToUnsigned(CInt(CSng(Horz_K2.Text) * 256)) >> 8) And &HFF)
        Buf(9) = CByte(IntToUnsigned(CInt(CSng(Horz_K2.Text) * 256)) And &HFF)

        Buf(10) = CByte((IntToUnsigned(CInt(CSng(Horz_K3.Text) * 256)) >> 8) And &HFF)
        Buf(11) = CByte(IntToUnsigned(CInt(CSng(Horz_K3.Text) * 256)) And &HFF)

        Buf(12) = CByte((IntToUnsigned(CInt(CSng(Vert_K1.Text) * 256)) >> 8) And &HFF)
        Buf(13) = CByte(IntToUnsigned(CInt(CSng(Vert_K1.Text) * 256)) And &HFF)

        Buf(14) = CByte((IntToUnsigned(CInt(CSng(Vert_K2.Text) * 256)) >> 8) And &HFF)
        Buf(15) = CByte(IntToUnsigned(CInt(CSng(Vert_K2.Text) * 256)) And &HFF)

        Buf(16) = CByte((IntToUnsigned(CInt(CSng(Vert_K3.Text) * 256)) >> 8) And &HFF)
        Buf(17) = CByte(IntToUnsigned(CInt(CSng(Vert_K3.Text) * 256)) And &HFF)

        CommPort.Write(Buf)
    End Sub
    Private Function IntToUnsigned(ByVal Value As Integer) As UInteger
        If Value < 0 Then
            IntToUnsigned = CUInt(Value + OFFSET_4)
        Else
            IntToUnsigned = CUInt(Value)
        End If
    End Function
    Private Function UnsignedToInteger(ByVal Value As Long) As Int16
        If Value < 0 Or Value >= OFFSET_2 Then Error 6 ' Overflow
        If Value <= MAXINT_2 Then
            UnsignedToInteger = CShort(Value)
        Else
            UnsignedToInteger = CShort(Value - OFFSET_2)
        End If
    End Function
    Private Function UnsignedToInt(ByVal Value As Long) As Integer
        If Value <= MAXINT_4 Then
            UnsignedToInt = CInt(Value)
        Else
            UnsignedToInt = CInt(Value - OFFSET_4)
        End If
    End Function

    Private Sub Horz_Kd_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Kd.Enter
        Horz_K1.Text = CStr(CSng(Horz_Kp.Text) + CSng(Horz_Ki.Text) / 256 + CSng(Horz_Kd.Text) * 128)
        Horz_K2.Text = CStr(-CSng(Horz_Kp.Text) + -256 * CSng(Horz_Kd.Text) + CSng(Horz_Ki.Text) / 256)
        Horz_K3.Text = CStr(CSng(Horz_Kd.Text) * 128)
        Horz_K1.Text = CStr(CSng(Horz_Kp.Text) + CSng(Horz_Ki.Text) / 128 + CSng(Horz_Kd.Text) * 64)
        Horz_K2.Text = CStr(-CSng(Horz_Kp.Text) + -128 * CSng(Horz_Kd.Text) + CSng(Horz_Ki.Text) / 128)
        Horz_K3.Text = CStr(CSng(Horz_Kd.Text) * 64)

    End Sub
    Private Sub Horz_Ki_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Ki.Enter
        Horz_K1.Text = CStr(CSng(Horz_Kp.Text) + CSng(Horz_Ki.Text) / 256 + CSng(Horz_Kd.Text) * 128)
        Horz_K2.Text = CStr(-CSng(Horz_Kp.Text) + -256 * CSng(Horz_Kd.Text) + CSng(Horz_Ki.Text) / 256)
        Horz_K3.Text = CStr(CSng(Horz_Kd.Text) * 128)
        Horz_K1.Text = CStr(CSng(Horz_Kp.Text) + CSng(Horz_Ki.Text) / 128 + CSng(Horz_Kd.Text) * 64)
        Horz_K2.Text = CStr(-CSng(Horz_Kp.Text) + -128 * CSng(Horz_Kd.Text) + CSng(Horz_Ki.Text) / 128)
        Horz_K3.Text = CStr(CSng(Horz_Kd.Text) * 64)

    End Sub
    Private Sub Horz_Kp_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Kp.Enter
        Horz_K1.Text = CStr(CSng(Horz_Kp.Text) + CSng(Horz_Ki.Text) / 256 + CSng(Horz_Kd.Text) * 128)
        Horz_K2.Text = CStr(-CSng(Horz_Kp.Text) + -256 * CSng(Horz_Kd.Text) + CSng(Horz_Ki.Text) / 256)
        Horz_K3.Text = CStr(CSng(Horz_Kd.Text) * 128)
        Horz_K1.Text = CStr(CSng(Horz_Kp.Text) + CSng(Horz_Ki.Text) / 128 + CSng(Horz_Kd.Text) * 64)
        Horz_K2.Text = CStr(-CSng(Horz_Kp.Text) + -128 * CSng(Horz_Kd.Text) + CSng(Horz_Ki.Text) / 128)
        Horz_K3.Text = CStr(CSng(Horz_Kd.Text) * 64)

    End Sub
    Private Sub Vert_Kd_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Kd.Enter
        Vert_K1.Text = CStr(CSng(Vert_Kp.Text) + CSng(Vert_Ki.Text) / 256 + CSng(Vert_Kd.Text) * 128)
        Vert_K2.Text = CStr(-CSng(Vert_Kp.Text) + -256 * CSng(Vert_Kd.Text) + CSng(Vert_Ki.Text) / 256)
        Vert_K3.Text = CStr(CSng(Vert_Kd.Text) * 128)
        Vert_K1.Text = CStr(CSng(Vert_Kp.Text) + CSng(Vert_Ki.Text) / 128 + CSng(Vert_Kd.Text) * 64)
        Vert_K2.Text = CStr(-CSng(Vert_Kp.Text) + -128 * CSng(Vert_Kd.Text) + CSng(Vert_Ki.Text) / 128)
        Vert_K3.Text = CStr(CSng(Vert_Kd.Text) * 64)

    End Sub
    Private Sub Vert_Ki_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Ki.Enter
        Vert_K1.Text = CStr(CSng(Vert_Kp.Text) + CSng(Vert_Ki.Text) / 256 + CSng(Vert_Kd.Text) * 128)
        Vert_K2.Text = CStr(-CSng(Vert_Kp.Text) + -256 * CSng(Vert_Kd.Text) + CSng(Vert_Ki.Text) / 256)
        Vert_K3.Text = CStr(CSng(Vert_Kd.Text) * 128)
        Vert_K1.Text = CStr(CSng(Vert_Kp.Text) + CSng(Vert_Ki.Text) / 128 + CSng(Vert_Kd.Text) * 64)
        Vert_K2.Text = CStr(-CSng(Vert_Kp.Text) + -128 * CSng(Vert_Kd.Text) + CSng(Vert_Ki.Text) / 128)
        Vert_K3.Text = CStr(CSng(Vert_Kd.Text) * 64)

    End Sub
    Private Sub Vert_Kp_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Kp.Enter
        Vert_K1.Text = CStr(CSng(Vert_Kp.Text) + CSng(Vert_Ki.Text) / 256 + CSng(Vert_Kd.Text) * 128)
        Vert_K2.Text = CStr(-CSng(Vert_Kp.Text) + -256 * CSng(Vert_Kd.Text) + CSng(Vert_Ki.Text) / 256)
        Vert_K3.Text = CStr(CSng(Vert_Kd.Text) * 128)
        Vert_K1.Text = CStr(CSng(Vert_Kp.Text) + CSng(Vert_Ki.Text) / 128 + CSng(Vert_Kd.Text) * 64)
        Vert_K2.Text = CStr(-CSng(Vert_Kp.Text) + -128 * CSng(Vert_Kd.Text) + CSng(Vert_Ki.Text) / 128)
        Vert_K3.Text = CStr(CSng(Vert_Kd.Text) * 64)

    End Sub



    Private Sub Horz_Kd_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Kd.HandleCreated
        Horz_Kd.Text = "0"
    End Sub

    Private Sub Horz_Ki_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Ki.HandleCreated
        Horz_Ki.Text = "0"
    End Sub

    Private Sub Horz_Kp_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Kp.HandleCreated
        Horz_Kp.Text = "0"
    End Sub

    Private Sub Horz_Set_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_Set.HandleCreated
        Horz_Set.Text = "0"
    End Sub

    Private Sub Vert_Kd_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Kd.HandleCreated
        Vert_Kd.Text = "0"
    End Sub

    Private Sub Vert_Ki_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Ki.HandleCreated
        Vert_Ki.Text = "0"
    End Sub

    Private Sub Vert_Kp_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Kp.HandleCreated
        Vert_Kp.Text = "0"
    End Sub

    Private Sub Vert_Set_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_Set.HandleCreated
        Vert_Set.Text = "782"
    End Sub

    Private Sub Horz_K1_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_K1.HandleCreated
        Horz_K1.Text = "0"
    End Sub

    Private Sub Horz_K2_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_K2.HandleCreated
        Horz_K2.Text = "0"
    End Sub

    Private Sub Horz_K3_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Horz_K3.HandleCreated
        Horz_K3.Text = "0"
    End Sub

    Private Sub Vert_K1_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_K1.HandleCreated
        Vert_K1.Text = "0"
    End Sub

    Private Sub Vert_K2_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_K2.HandleCreated
        Vert_K2.Text = "0"
    End Sub

    Private Sub Vert_K3_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vert_K3.HandleCreated
        Vert_K3.Text = "0"
    End Sub
End Class
